function rad2deg(angle) {
  return(angle/Math.PI*180.0);
}

function deg2rad(angle) {
  return(angle/180.0*Math.PI);
}

inlets = 1;
outlets = 2;
sketch.default2d();

var col = 1 ;
var x = new Array(10);
var y = new Array(10);
var z = new Array(10);
var dist = 1;
var scale = 1;
var col1 = [1.0,0.8,0.6,0.4,0.2,0.0,1.0,0.8,0.6,0.4,0.2,0.0] ;
var col2 = [0.0,0.2,0.4,0.6,0.8,1.0,0.0,0.2,0.4,0.6,0.8,1.0] ;
var col3 = [1.0,0.0,1.0,0.0,1.0,0.0,0.0,1.0,0.0,1.0,0.0,1.0] ;
//---------
var _elevation = 0.0;
var _points = new Array();
var _pointsSizes = new Array();
var _pointsDists = new Array();
var diff_point_mouse = new Array();
var isdraging = false ;
var dragingindex = 0 ; 
var indexNearest = 0;



function setElevation(curelev) {
	_elevation = curelev;
}

function onidle(mousex,mousey){
	isdraging = false ;
}

function ondrag(mousex,mousey, button , modifier1 , shift, capslock , option , modifier2) {
  if (shift){
  		var newPointAbcOrd = sketch.screentoworld(mousex,mousey) ;
  		var dragPt = [newPointAbcOrd[0]*scale,newPointAbcOrd[1]*scale] ;
  		var _thresh = 0.4;
  		if (isdraging==false){
  			indexNearest = 0;
  			if (_points.length > 0){
  				distNearest = Math.sqrt((_points[0][0]-dragPt[0])*(_points[0][0]-dragPt[0]) + (_points[0][1] - dragPt[1])*(_points[0][1] - dragPt[1]));
  			}
  		
  		for (ind=0;ind<_points.length;ind++)	{ 
  			if (distNearest > Math.sqrt((_points[ind][0]-dragPt[0])*(_points[ind][0]-dragPt[0]) + (_points[ind][1] - dragPt[1])*(_points[ind][1] - dragPt[1]))) {
  				distNearest = Math.sqrt((_points[ind][0]-dragPt[0])*(_points[ind][0]-dragPt[0]) + (_points[ind][1] - dragPt[1])*(_points[ind][1] - dragPt[1]));
  				indexNearest = ind;
  				dragingindex = indexNearest ;
  				//isdraging=true ;
  			}
  		}
  			
  		if (distNearest < _thresh){ isdraging=true ; }
  		}		
		if (isdraging==true) {
			_points[indexNearest] = [dragPt[0] , dragPt[1] , _points[indexNearest][2]];
			output(indexNearest)
			draw();
		}
	}
}


function onidle(mousex,mousey){
	isdraging = false ;
}



function onclick(mousex , mousey , button , modifier1 , shift, capslock , option , modifier2) {
	if (modifier1 && !shift && !capslock && !option && !modifier2 ) {
		var newPointAbcOrd = sketch.screentoworld(mousex,mousey)
		_pointsSizes[_points.length] = (_elevation+1)*0.04+0.03;
		_points[_points.length] = [newPointAbcOrd[0]*scale , newPointAbcOrd[1]*scale , _elevation];
		output(_points.length-1) ;
		draw();
	}
}

//---------

function draw() {
  // background
  sketch.glclearcolor(0.0,0.0,0.0,1.0);
  sketch.glclear();
  // head
  sketch.moveto(0,0,0);
  sketch.glcolor(1.0,1.0,1.0,1.0);
  sketch.circle(0.0875/scale);
  // radius 1
  sketch.moveto(0,0,0);
  sketch.glcolor(1.0,1.0,1.0,1.0);
  sketch.framecircle(1/scale);
  // object 
  for (ind =0;ind<_points.length;ind++)	{ 
  		sketch.moveto(_points[ind][0]/scale , _points[ind][1]/scale , _points[ind][2]);
  		sketch.glcolor(col1[ind % col1.length] , col2[ind % col1.length] , col3[ind % col1.length] ,1.0);
  		//post("points "+ ind+ " : "+ _points[ind][2] + "\n");
 		sketch.circle(_pointsSizes[ind]/scale);
 		if (_points[ind][2]<0){
 			  // head
  			sketch.moveto(0,0,0);
  			sketch.glcolor(1.0,1.0,1.0,1.0);
  			sketch.circle(0.0875/scale);
  		}
  }
  for (ind =0;ind<_points.length;ind++)	{ 
  	if (_points[ind][2]>=0){
  		sketch.moveto(_points[ind][0]/scale , _points[ind][1]/scale , _points[ind][2]);
  		sketch.glcolor(col1[ind % col1.length] , col2[ind % col1.length] , col3[ind % col1.length] ,1.0);
  		//post("points "+ ind+ " : "+ _points[ind][2] + "\n");
 		sketch.circle(_pointsSizes[ind]/scale);
 	}
  }
  
  //
  refresh();
}

function output(pt) {
  dist = Math.sqrt(_points[pt][0]*_points[pt][0]+_points[pt][1]*_points[pt][1]+_points[pt][2]*_points[pt][2]);
  outlet(1,pt,_points[pt][1],-_points[pt][0],_points[pt][2]);
  outlet(0,pt,"position",rad2deg(Math.atan2(-_points[pt][0],_points[pt][1])),rad2deg(Math.asin(_points[pt][2]/dist)),dist);
}

function zoom(value) {
  if (value<0.1) {
    scale = 0.1;
  } else {
    scale = value;
  }
  draw();
}

function src_pos(pt,az,el,dist) {
  if (pt<_points.length) {nb_pt=pt ;}
  	else{
  		nb_pt=_points.length ;
	}
  cosel = Math.cos(deg2rad(el));
  _points[nb_pt] = [-dist*Math.sin(deg2rad(az))*cosel,dist*Math.cos(deg2rad(az))*cosel,dist*Math.sin(deg2rad(el))];
	
  _pointsSizes[nb_pt] = (dist*Math.sin(deg2rad(el))+1)*0.04+0.03;
  draw();
  output(nb_pt);
}

function onresize(width,height) {
  draw();
}

onresize.local = 1;
draw();

  



